=== textautocorrection/CMakeLists.txt ===
# SPDX-License-Identifier: BSD-3-Clause
# SPDX-FileCopyrightText: none
add_definitions(-DTRANSLATION_DOMAIN=\"libtextautocorrection\")

add_subdirectory(core)
add_subdirectory(widgets)
