=== textaddonswidgets/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_subdirectory(slidecontainergui)
add_subdirectory(richtextquicktextformatgui)
