=== debian/changelog ===
ktextaddons (1.8.0-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release 1.8.0 (Closes: #1117350).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.7.2 (no changes needed).
  * Add upstream signing key of Laurent Montel.
  * Update list of installed files and new binary packages.
  * Drop Rules-Requires-Root: no, not needed any more.
  * Update d/copyright.

 -- Patrick Franz <deltaone@debian.org>  Sun, 12 Oct 2025 14:07:04 +0200
