=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_QCH=ON -DBUILD_TESTING=OFF -DQT_MAJOR_VERSION=6

override_dh_makeshlibs:
	dh_makeshlibs -Xlibtextautogenerategenericnetwork -Xlibtextautogenerateollama
