=== debian/watch ===
version=4
opts=pgpsigurlmangle=s/$/.sig/ https://download.kde.org/stable/ktextaddons/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
